{{File: TestPwm.spin
Starts with four 50% duty cycle signals:
    P4 - 10 kHz
    P5 - 20 kHz
    P6 - 30 kHz
    P7 - 40 kHz
Loops P6 from 0 to 100 % as it loops P7 from 100 to 0%.
}}
CON

    _xinfreq = 5_000_000                      
    _clkmode = xtal1 | pll16x

    high = 0
    cycle = 1
    pinBase = 4

VAR

    long dutycycle[4], frequency[4]

OBJ

    pwm[4]  : "pwm"      
    
PUB init | i

    ' Start 4 motors at differenent frequencies:
    ' 10 kHz, 20 kHz, 30 kHz and 40 kHz.
    
    repeat i from 0 to 3
      dutyCycle[i] := 50
      frequency[i] := (i + 1) * 10000

    main 

PUB main | i, duty, freq

    repeat i from 0 to 3
      duty := dutycycle[i]
      freq := frequency[i]
      calcticks(@duty, @freq)
      pwm[i].start(PinBase + i, duty, freq)
   
    repeat
      repeat duty from 0 to 100
        dutycycle[2] := duty
        dutycycle[3] := 100 - duty
        update(2, dutycycle[2], frequency[2])
        update(3, dutycycle[3], frequency[3])
        
PRI update(index, duty, freq):okay
    {{Send a signal of a certain duty cycle at a specified frquency
     
        pin       - I/O pin that sends the signal
        dutyCycle - duty cycle, 0 is 0.000%, 100_000 is 100.000%
        freq      - frequency of the signal in Hz}}
        
    calcticks(@duty, @freq) 
    pwm[index].update(duty, freq)
     
PRI calcticks(dutyaddr, freqaddr) | duty, freq, temp

    ' Duty cycle is 3 sf (0..100 -> 0 to 100%).
    ' for 6 sf, change the 100s to 100_000s 

    duty := long[dutyaddr]
    freq := long[freqaddr]

    freq := clkfreq / freq
    duty := freq * duty / 100
    if (temp := (((freq * duty) // 100) * 10)/100) => 5 'round up/dn
       duty += 1

    long[dutyaddr] := duty
    long[freqaddr] := freq

     