'' File: pwm.spin
'' Generates a pwm signal.

CON

 _clkmode = xtal1 + pll16x
 _xinfreq = 5_000_000

VAR

  long duty, period, pin
  byte cog

PUB start(ioPin, tHigh, tCycle) : okay
{{Start cog and PWM signal
    ioPin - selects I/O pin for sending the signal
    tHigh - number of clock ticks high
    tLow  - number of clock ticks low
}}
    pin    := ioPin
    duty   := tHigh
    period := tCycle

    okay   := cog := cognew(@entry, @duty)

PUB stop
''Stop cog and PWM signal
    waitpeq(0, |< pin, 0)
    dira[pin] := 0  
    if cog > 0
      cogstop(cog)

PUB update(tHigh, tCycle)
    '' tHigh and tCycle should be in terms of clock ticks
    duty := tHigh
    period := tCycle
    
DAT

entry                   movi   ctra,#%00100_000
                        movd   ctra,#0

                        mov     addr, par
                        add     addr, #8
                        rdword  _pin, addr
                        movs    ctra,_pin

                        mov     temp, #1
                        shl     temp,_pin
                        or      dira,temp

                        mov     frqa,#1

                        mov     addr, par
                        add     addr, #4 
                        rdlong  _cntadd, addr
                        
                        mov     cntacc,cnt
                        add     cntacc,_cntadd

:loop                   waitcnt cntacc,_cntadd
                        rdlong  _duty,par
                        mov     temp, par       '
                        add     temp, #1        '
                        rdlong  _duty, temp     '
                        neg     phsa,_duty
                        jmp     #:loop

cntacc                  res     1
_duty                   res     1
_cntadd                 res     1
_pin                    res     1
addr                    res     1
temp                    res     1